Compare commits

..

9 Commits

Author SHA1 Message Date
decentral1se c7f838178c
WIP WORLD
continuous-integration/drone/pr Build is failing Details
2021-06-11 00:43:45 +02:00
decentral1se 2ca7884bbe
Fix bump releases
continuous-integration/drone/push Build is passing Details
Closes https://git.autonomic.zone/coop-cloud/abra/issues/180.
2021-06-11 00:36:40 +02:00
decentral1se fa54705f79 Merge pull request 'Prefer --fast for skipping all checks' (#175) from prefer-fast-option into main
continuous-integration/drone/push Build is passing Details
Reviewed-on: https://git.autonomic.zone/coop-cloud/abra/pulls/175
2021-06-11 00:29:20 +02:00
decentral1se 8d802c78aa
Prefer --fast for skipping all checks
continuous-integration/drone/pr Build is passing Details
Closes https://git.autonomic.zone/coop-cloud/abra/issues/169
2021-06-11 00:27:50 +02:00
decentral1se 1c022fb616 Merge pull request 'Add --bump release logic' (#176) from add-bump-logic into main
continuous-integration/drone/push Build is passing Details
Reviewed-on: https://git.autonomic.zone/coop-cloud/abra/pulls/176
2021-06-10 12:19:35 +02:00
decentral1se 0655c03434
Add --bump release logic
continuous-integration/drone/pr Build is passing Details
Closes https://git.autonomic.zone/coop-cloud/abra/issues/173.
2021-06-10 12:18:27 +02:00
decentral1se f6bdf596f5
Bump to next version
continuous-integration/drone/push Build is passing Details
2021-06-10 11:43:00 +02:00
decentral1se 6c6e6808c9 Merge pull request 'Add --chaos flag' (#179) from chaos-deploy-flag into main
continuous-integration/drone/push Build is passing Details
Reviewed-on: https://git.autonomic.zone/coop-cloud/abra/pulls/179
2021-06-10 11:41:26 +02:00
decentral1se a3ffd7f239
Add --chaos flag
continuous-integration/drone/pr Build is passing Details
Closes https://git.autonomic.zone/coop-cloud/abra/issues/178.
2021-06-10 11:40:25 +02:00
3 changed files with 165 additions and 143 deletions

View File

@ -9,12 +9,18 @@
# abra x.x.x (UNRELEASED)
- Add `--bump` to `deploy` command to allow packagers to make minor package related releases ([#173](https://git.autonomic.zone/coop-cloud/abra/issues/173))
- Drop `--skip-version-check`/`--no-domain-poll`/`--no-state-poll` in favour of `--fast` ([#169](https://git.autonomic.zone/coop-cloud/abra/issues/169))
# abra 9.0.0 (2021-06-10)
- Add Docker image for `abra` ([64d578cf91](https://git.autonomic.zone/coop-cloud/abra/commit/64d578cf914bd2bad378ea4ef375747d10b33191))
- Support unattended mode for recipe releasing ([3759bcd641](https://git.autonomic.zone/coop-cloud/abra/commit/3759bcd641cf60611c13927e83425e773d2bb629))
- Add Renovate bot configuraiton script ([9fadc430a7](https://git.autonomic.zone/coop-cloud/abra/commit/9fadc430a7bb2d554c0ee26c0f9b6c51dc5b0475))
- Add release automation via [drone-abra](https://git.autonomic.zone/coop-cloud/drone-abra) ([#56](https://git.autonomic.zone/coop-cloud/organising/issues/56))
- Move `apps.json` generation to [auto-apps-json](https://git.autonomic.zone/coop-cloud/auto-apps-json) ([#125](https://git.autonomic.zone/coop-cloud/abra/issues/125))
- Add Github mirroring script ([4ef433312d](https://git.autonomic.zone/coop-cloud/abra/commit/4ef433312dd0b0ace91b3c285f82f3973093d92d))
- Add `--chaos` flag to deploy (always choose latest Git commit) ([#178](https://git.autonomic.zone/coop-cloud/abra/issues/178))
# abra 8.0.1 (2021-05-31)

300
abra
View File

@ -3,7 +3,7 @@
GIT_URL="https://git.autonomic.zone/coop-cloud/"
ABRA_APPS_URL="https://apps.coopcloud.tech"
ABRA_DIR="${ABRA_DIR:-$HOME/.abra}"
ABRA_VERSION="8.0.1"
ABRA_VERSION="9.0.0"
ABRA_BACKUP_DIR="${ABRA_BACKUP_DIR:-$ABRA_DIR/backups}"
ABRA_VENDOR_DIR="$ABRA_DIR/vendor"
ABRA_APPS_JSON="${ABRA_DIR}/apps.json"
@ -19,7 +19,7 @@ Usage:
abra [options] app (list|ls) [--status] [--server=<server>] [--type=<type>]
abra [options] app new [--server=<server>] [--domain=<domain>] [--app-name=<app_name>] [--pass] [--secrets] <type>
abra [options] app <app> backup (<service>|--all)
abra [options] app <app> deploy [--update] [--force] [--fast] [--skip-version-check] [--no-domain-poll] [--no-state-poll] [<version>]
abra [options] app <app> deploy [--update] [--force] [--fast] [--chaos] [<version>]
abra [options] app <app> check
abra [options] app <app> version
abra [options] app <app> config
@ -40,7 +40,7 @@ Usage:
abra [options] app <app> <command> [<args>...]
abra [options] recipe ls
abra [options] recipe create <recipe>
abra [options] recipe <recipe> release [--force]
abra [options] recipe <recipe> release [--force] [--bump]
abra [options] recipe <recipe> versions
abra [options] server add <host> [<user>] [<port>]
abra [options] server new <provider> -- <args>
@ -167,130 +167,127 @@ eval "var_$1+=($value)"; else eval "var_$1=$value"; fi; return 0; fi; done
return 1; }; stdout() { printf -- "cat <<'EOM'\n%s\nEOM\n" "$1"; }; stderr() {
printf -- "cat <<'EOM' >&2\n%s\nEOM\n" "$1"; }; error() {
[[ -n $1 ]] && stderr "$1"; stderr "$usage"; _return 1; }; _return() {
printf -- "exit %d\n" "$1"; exit "$1"; }; set -e; trimmed_doc=${DOC:1:2492}
usage=${DOC:40:1883}; digest=f774b
shorts=(-e -s -U -h -C -v -d -n -b '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '')
longs=(--env --stack --skip-update --help --skip-check --verbose --debug --no-prompt --branch --status --server --type --domain --app-name --pass --secrets --all --update --force --fast --skip-version-check --no-domain-poll --no-state-poll --volumes --no-tty --user --dev)
argcounts=(1 1 0 0 0 0 0 0 1 0 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 1 0); node_0(){
value __env 0; }; node_1(){ value __stack 1; }; node_2(){ switch __skip_update 2
}; node_3(){ switch __help 3; }; node_4(){ switch __skip_check 4; }; node_5(){
switch __verbose 5; }; node_6(){ switch __debug 6; }; node_7(){
switch __no_prompt 7; }; node_8(){ value __branch 8; }; node_9(){
printf -- "exit %d\n" "$1"; exit "$1"; }; set -e; trimmed_doc=${DOC:1:2451}
usage=${DOC:40:1842}; digest=c7bae
shorts=(-C -n -b -U -h -e -s -v -d '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '' '')
longs=(--skip-check --no-prompt --branch --skip-update --help --env --stack --verbose --debug --status --server --type --domain --app-name --pass --secrets --all --update --force --fast --chaos --volumes --no-tty --user --bump --dev)
argcounts=(0 0 1 0 0 1 1 0 0 0 1 1 1 1 0 0 0 0 0 0 0 0 0 1 0 0); node_0(){
switch __skip_check 0; }; node_1(){ switch __no_prompt 1; }; node_2(){
value __branch 2; }; node_3(){ switch __skip_update 3; }; node_4(){
switch __help 4; }; node_5(){ value __env 5; }; node_6(){ value __stack 6; }
node_7(){ switch __verbose 7; }; node_8(){ switch __debug 8; }; node_9(){
switch __status 9; }; node_10(){ value __server 10; }; node_11(){
value __type 11; }; node_12(){ value __domain 12; }; node_13(){
value __app_name 13; }; node_14(){ switch __pass 14; }; node_15(){
switch __secrets 15; }; node_16(){ switch __all 16; }; node_17(){
switch __update 17; }; node_18(){ switch __force 18; }; node_19(){
switch __fast 19; }; node_20(){ switch __skip_version_check 20; }; node_21(){
switch __no_domain_poll 21; }; node_22(){ switch __no_state_poll 22; }
node_23(){ switch __volumes 23; }; node_24(){ switch __no_tty 24; }; node_25(){
value __user 25; }; node_26(){ switch __dev 26; }; node_27(){ value _type_ a; }
node_28(){ value _app_ a; }; node_29(){ value _service_ a; }; node_30(){
value _version_ a; }; node_31(){ value _src_ a; }; node_32(){ value _dst_ a; }
node_33(){ value _backup_file_ a; }; node_34(){ value _args_ a true; }
node_35(){ value _secret_ a; }; node_36(){ value _cmd_ a; }; node_37(){
value _data_ a; }; node_38(){ value _volume_ a; }; node_39(){ value _command_ a
}; node_40(){ value _recipe_ a; }; node_41(){ value _host_ a; }; node_42(){
value _user_ a; }; node_43(){ value _port_ a; }; node_44(){ value _provider_ a
}; node_45(){ value _subcommands_ a true; }; node_46(){ _command app; }
node_47(){ _command list; }; node_48(){ _command ls; }; node_49(){ _command new
}; node_50(){ _command backup; }; node_51(){ _command deploy; }; node_52(){
_command check; }; node_53(){ _command version; }; node_54(){ _command config; }
node_55(){ _command cp; }; node_56(){ _command logs; }; node_57(){ _command ps
}; node_58(){ _command restore; }; node_59(){ _command rm; }; node_60(){
_command delete; }; node_61(){ _command run; }; node_62(){ _command rollback; }
node_63(){ _command secret; }; node_64(){ _command generate; }; node_65(){
_command insert; }; node_66(){ _command undeploy; }; node_67(){ _command volume
}; node_68(){ _command recipe; }; node_69(){ _command create; }; node_70(){
_command release; }; node_71(){ _command versions; }; node_72(){ _command server
}; node_73(){ _command add; }; node_74(){ _command __ --; }; node_75(){
_command init; }; node_76(){ _command apps; }; node_77(){ _command upgrade; }
node_78(){ _command doctor; }; node_79(){ _command help; }; node_80(){
optional 0 1 2 3 4 5 6 7 8; }; node_81(){ optional 80; }; node_82(){
either 47 48; }; node_83(){ required 82; }; node_84(){ optional 9; }; node_85(){
optional 10; }; node_86(){ optional 11; }; node_87(){ required 81 46 83 84 85 86
}; node_88(){ optional 12; }; node_89(){ optional 13; }; node_90(){ optional 14
}; node_91(){ optional 15; }; node_92(){ required 81 46 49 85 88 89 90 91 27; }
node_93(){ either 29 16; }; node_94(){ required 93; }; node_95(){
required 81 46 28 50 94; }; node_96(){ optional 17; }; node_97(){ optional 18; }
node_98(){ optional 19; }; node_99(){ optional 20; }; node_100(){ optional 21; }
node_101(){ optional 22; }; node_102(){ optional 30; }; node_103(){
required 81 46 28 51 96 97 98 99 100 101 102; }; node_104(){
required 81 46 28 52; }; node_105(){ required 81 46 28 53; }; node_106(){
required 81 46 28 54; }; node_107(){ required 81 46 28 55 31 32; }; node_108(){
optional 29; }; node_109(){ required 81 46 28 56 108; }; node_110(){
required 81 46 28 57; }; node_111(){ required 81 46 28 58 94; }; node_112(){
either 59 60; }; node_113(){ required 112; }; node_114(){ optional 23; }
node_115(){ required 81 46 28 113 114 91; }; node_116(){ optional 33; }
node_117(){ required 81 46 28 58 29 116; }; node_118(){ optional 24; }
node_119(){ optional 25; }; node_120(){ oneormore 34; }; node_121(){
required 81 46 28 61 118 119 29 120; }; node_122(){ required 81 46 28 62 102; }
node_123(){ required 35 30; }; node_124(){ either 123 16; }; node_125(){
required 124; }; node_126(){ optional 36; }; node_127(){
required 81 46 28 63 64 125 126 90; }; node_128(){
required 81 46 28 63 65 35 30 37 90; }; node_129(){ either 35 16; }; node_130(){
required 129; }; node_131(){ required 81 46 28 63 113 130 90; }; node_132(){
required 81 46 28 66; }; node_133(){ required 81 46 28 67 48; }; node_134(){
either 38 16; }; node_135(){ required 134; }; node_136(){
required 81 46 28 67 113 135; }; node_137(){ optional 120; }; node_138(){
required 81 46 28 39 137; }; node_139(){ required 81 68 48; }; node_140(){
required 81 68 69 40; }; node_141(){ required 81 68 40 70 97; }; node_142(){
required 81 68 40 71; }; node_143(){ optional 42; }; node_144(){ optional 43; }
node_145(){ required 81 72 73 41 143 144; }; node_146(){
required 81 72 49 44 74 34; }; node_147(){ required 81 72 83; }; node_148(){
required 81 72 41 59; }; node_149(){ required 81 72 41 75; }; node_150(){
required 81 72 41 76 84; }; node_151(){ optional 26; }; node_152(){
required 81 77 151; }; node_153(){ required 81 53; }; node_154(){ required 81 78
}; node_155(){ oneormore 45; }; node_156(){ optional 155; }; node_157(){
required 81 79 156; }; node_158(){ required 81; }; node_159(){
either 87 92 95 103 104 105 106 107 109 110 111 115 117 121 122 127 128 131 132 133 136 138 139 140 141 142 145 146 147 148 149 150 152 153 154 157 158
}; node_160(){ required 159; }; cat <<<' docopt_exit() {
[[ -n $1 ]] && printf "%s\n" "$1" >&2; printf "%s\n" "${DOC:40:1883}" >&2
exit 1; }'; unset var___env var___stack var___skip_update var___help \
var___skip_check var___verbose var___debug var___no_prompt var___branch \
switch __fast 19; }; node_20(){ switch __chaos 20; }; node_21(){
switch __volumes 21; }; node_22(){ switch __no_tty 22; }; node_23(){
value __user 23; }; node_24(){ switch __bump 24; }; node_25(){ switch __dev 25
}; node_26(){ value _type_ a; }; node_27(){ value _app_ a; }; node_28(){
value _service_ a; }; node_29(){ value _version_ a; }; node_30(){ value _src_ a
}; node_31(){ value _dst_ a; }; node_32(){ value _backup_file_ a; }; node_33(){
value _args_ a true; }; node_34(){ value _secret_ a; }; node_35(){ value _cmd_ a
}; node_36(){ value _data_ a; }; node_37(){ value _volume_ a; }; node_38(){
value _command_ a; }; node_39(){ value _recipe_ a; }; node_40(){ value _host_ a
}; node_41(){ value _user_ a; }; node_42(){ value _port_ a; }; node_43(){
value _provider_ a; }; node_44(){ value _subcommands_ a true; }; node_45(){
_command app; }; node_46(){ _command list; }; node_47(){ _command ls; }
node_48(){ _command new; }; node_49(){ _command backup; }; node_50(){
_command deploy; }; node_51(){ _command check; }; node_52(){ _command version; }
node_53(){ _command config; }; node_54(){ _command cp; }; node_55(){
_command logs; }; node_56(){ _command ps; }; node_57(){ _command restore; }
node_58(){ _command rm; }; node_59(){ _command delete; }; node_60(){
_command run; }; node_61(){ _command rollback; }; node_62(){ _command secret; }
node_63(){ _command generate; }; node_64(){ _command insert; }; node_65(){
_command undeploy; }; node_66(){ _command volume; }; node_67(){ _command recipe
}; node_68(){ _command create; }; node_69(){ _command release; }; node_70(){
_command versions; }; node_71(){ _command server; }; node_72(){ _command add; }
node_73(){ _command __ --; }; node_74(){ _command init; }; node_75(){
_command apps; }; node_76(){ _command upgrade; }; node_77(){ _command doctor; }
node_78(){ _command help; }; node_79(){ optional 0 1 2 3 4 5 6 7 8; }
node_80(){ optional 79; }; node_81(){ either 46 47; }; node_82(){ required 81; }
node_83(){ optional 9; }; node_84(){ optional 10; }; node_85(){ optional 11; }
node_86(){ required 80 45 82 83 84 85; }; node_87(){ optional 12; }; node_88(){
optional 13; }; node_89(){ optional 14; }; node_90(){ optional 15; }; node_91(){
required 80 45 48 84 87 88 89 90 26; }; node_92(){ either 28 16; }; node_93(){
required 92; }; node_94(){ required 80 45 27 49 93; }; node_95(){ optional 17; }
node_96(){ optional 18; }; node_97(){ optional 19; }; node_98(){ optional 20; }
node_99(){ optional 29; }; node_100(){ required 80 45 27 50 95 96 97 98 99; }
node_101(){ required 80 45 27 51; }; node_102(){ required 80 45 27 52; }
node_103(){ required 80 45 27 53; }; node_104(){ required 80 45 27 54 30 31; }
node_105(){ optional 28; }; node_106(){ required 80 45 27 55 105; }; node_107(){
required 80 45 27 56; }; node_108(){ required 80 45 27 57 93; }; node_109(){
either 58 59; }; node_110(){ required 109; }; node_111(){ optional 21; }
node_112(){ required 80 45 27 110 111 90; }; node_113(){ optional 32; }
node_114(){ required 80 45 27 57 28 113; }; node_115(){ optional 22; }
node_116(){ optional 23; }; node_117(){ oneormore 33; }; node_118(){
required 80 45 27 60 115 116 28 117; }; node_119(){ required 80 45 27 61 99; }
node_120(){ required 34 29; }; node_121(){ either 120 16; }; node_122(){
required 121; }; node_123(){ optional 35; }; node_124(){
required 80 45 27 62 63 122 123 89; }; node_125(){
required 80 45 27 62 64 34 29 36 89; }; node_126(){ either 34 16; }; node_127(){
required 126; }; node_128(){ required 80 45 27 62 110 127 89; }; node_129(){
required 80 45 27 65; }; node_130(){ required 80 45 27 66 47; }; node_131(){
either 37 16; }; node_132(){ required 131; }; node_133(){
required 80 45 27 66 110 132; }; node_134(){ optional 117; }; node_135(){
required 80 45 27 38 134; }; node_136(){ required 80 67 47; }; node_137(){
required 80 67 68 39; }; node_138(){ optional 24; }; node_139(){
required 80 67 39 69 96 138; }; node_140(){ required 80 67 39 70; }; node_141(){
optional 41; }; node_142(){ optional 42; }; node_143(){
required 80 71 72 40 141 142; }; node_144(){ required 80 71 48 43 73 33; }
node_145(){ required 80 71 82; }; node_146(){ required 80 71 40 58; }
node_147(){ required 80 71 40 74; }; node_148(){ required 80 71 40 75 83; }
node_149(){ optional 25; }; node_150(){ required 80 76 149; }; node_151(){
required 80 52; }; node_152(){ required 80 77; }; node_153(){ oneormore 44; }
node_154(){ optional 153; }; node_155(){ required 80 78 154; }; node_156(){
required 80; }; node_157(){
either 86 91 94 100 101 102 103 104 106 107 108 112 114 118 119 124 125 128 129 130 133 135 136 137 139 140 143 144 145 146 147 148 150 151 152 155 156
}; node_158(){ required 157; }; cat <<<' docopt_exit() {
[[ -n $1 ]] && printf "%s\n" "$1" >&2; printf "%s\n" "${DOC:40:1842}" >&2
exit 1; }'; unset var___skip_check var___no_prompt var___branch \
var___skip_update var___help var___env var___stack var___verbose var___debug \
var___status var___server var___type var___domain var___app_name var___pass \
var___secrets var___all var___update var___force var___fast \
var___skip_version_check var___no_domain_poll var___no_state_poll \
var___volumes var___no_tty var___user var___dev var__type_ var__app_ \
var__service_ var__version_ var__src_ var__dst_ var__backup_file_ var__args_ \
var__secret_ var__cmd_ var__data_ var__volume_ var__command_ var__recipe_ \
var__host_ var__user_ var__port_ var__provider_ var__subcommands_ var_app \
var_list var_ls var_new var_backup var_deploy var_check var_version var_config \
var_cp var_logs var_ps var_restore var_rm var_delete var_run var_rollback \
var_secret var_generate var_insert var_undeploy var_volume var_recipe \
var_create var_release var_versions var_server var_add var___ var_init \
var_apps var_upgrade var_doctor var_help; parse 160 "$@"
local prefix=${DOCOPT_PREFIX:-''}; unset "${prefix}__env" "${prefix}__stack" \
"${prefix}__skip_update" "${prefix}__help" "${prefix}__skip_check" \
"${prefix}__verbose" "${prefix}__debug" "${prefix}__no_prompt" \
"${prefix}__branch" "${prefix}__status" "${prefix}__server" "${prefix}__type" \
var___secrets var___all var___update var___force var___fast var___chaos \
var___volumes var___no_tty var___user var___bump var___dev var__type_ \
var__app_ var__service_ var__version_ var__src_ var__dst_ var__backup_file_ \
var__args_ var__secret_ var__cmd_ var__data_ var__volume_ var__command_ \
var__recipe_ var__host_ var__user_ var__port_ var__provider_ var__subcommands_ \
var_app var_list var_ls var_new var_backup var_deploy var_check var_version \
var_config var_cp var_logs var_ps var_restore var_rm var_delete var_run \
var_rollback var_secret var_generate var_insert var_undeploy var_volume \
var_recipe var_create var_release var_versions var_server var_add var___ \
var_init var_apps var_upgrade var_doctor var_help; parse 158 "$@"
local prefix=${DOCOPT_PREFIX:-''}; unset "${prefix}__skip_check" \
"${prefix}__no_prompt" "${prefix}__branch" "${prefix}__skip_update" \
"${prefix}__help" "${prefix}__env" "${prefix}__stack" "${prefix}__verbose" \
"${prefix}__debug" "${prefix}__status" "${prefix}__server" "${prefix}__type" \
"${prefix}__domain" "${prefix}__app_name" "${prefix}__pass" \
"${prefix}__secrets" "${prefix}__all" "${prefix}__update" "${prefix}__force" \
"${prefix}__fast" "${prefix}__skip_version_check" "${prefix}__no_domain_poll" \
"${prefix}__no_state_poll" "${prefix}__volumes" "${prefix}__no_tty" \
"${prefix}__user" "${prefix}__dev" "${prefix}_type_" "${prefix}_app_" \
"${prefix}_service_" "${prefix}_version_" "${prefix}_src_" "${prefix}_dst_" \
"${prefix}_backup_file_" "${prefix}_args_" "${prefix}_secret_" \
"${prefix}_cmd_" "${prefix}_data_" "${prefix}_volume_" "${prefix}_command_" \
"${prefix}_recipe_" "${prefix}_host_" "${prefix}_user_" "${prefix}_port_" \
"${prefix}_provider_" "${prefix}_subcommands_" "${prefix}app" "${prefix}list" \
"${prefix}ls" "${prefix}new" "${prefix}backup" "${prefix}deploy" \
"${prefix}check" "${prefix}version" "${prefix}config" "${prefix}cp" \
"${prefix}logs" "${prefix}ps" "${prefix}restore" "${prefix}rm" \
"${prefix}__fast" "${prefix}__chaos" "${prefix}__volumes" "${prefix}__no_tty" \
"${prefix}__user" "${prefix}__bump" "${prefix}__dev" "${prefix}_type_" \
"${prefix}_app_" "${prefix}_service_" "${prefix}_version_" "${prefix}_src_" \
"${prefix}_dst_" "${prefix}_backup_file_" "${prefix}_args_" \
"${prefix}_secret_" "${prefix}_cmd_" "${prefix}_data_" "${prefix}_volume_" \
"${prefix}_command_" "${prefix}_recipe_" "${prefix}_host_" "${prefix}_user_" \
"${prefix}_port_" "${prefix}_provider_" "${prefix}_subcommands_" \
"${prefix}app" "${prefix}list" "${prefix}ls" "${prefix}new" "${prefix}backup" \
"${prefix}deploy" "${prefix}check" "${prefix}version" "${prefix}config" \
"${prefix}cp" "${prefix}logs" "${prefix}ps" "${prefix}restore" "${prefix}rm" \
"${prefix}delete" "${prefix}run" "${prefix}rollback" "${prefix}secret" \
"${prefix}generate" "${prefix}insert" "${prefix}undeploy" "${prefix}volume" \
"${prefix}recipe" "${prefix}create" "${prefix}release" "${prefix}versions" \
"${prefix}server" "${prefix}add" "${prefix}__" "${prefix}init" "${prefix}apps" \
"${prefix}upgrade" "${prefix}doctor" "${prefix}help"
eval "${prefix}"'__env=${var___env:-}'
eval "${prefix}"'__stack=${var___stack:-}'
eval "${prefix}"'__skip_update=${var___skip_update:-false}'
eval "${prefix}"'__help=${var___help:-false}'
eval "${prefix}"'__skip_check=${var___skip_check:-false}'
eval "${prefix}"'__verbose=${var___verbose:-false}'
eval "${prefix}"'__debug=${var___debug:-false}'
eval "${prefix}"'__no_prompt=${var___no_prompt:-false}'
eval "${prefix}"'__branch=${var___branch:-}'
eval "${prefix}"'__skip_update=${var___skip_update:-false}'
eval "${prefix}"'__help=${var___help:-false}'
eval "${prefix}"'__env=${var___env:-}'
eval "${prefix}"'__stack=${var___stack:-}'
eval "${prefix}"'__verbose=${var___verbose:-false}'
eval "${prefix}"'__debug=${var___debug:-false}'
eval "${prefix}"'__status=${var___status:-false}'
eval "${prefix}"'__server=${var___server:-}'
eval "${prefix}"'__type=${var___type:-}'
@ -302,12 +299,11 @@ eval "${prefix}"'__all=${var___all:-false}'
eval "${prefix}"'__update=${var___update:-false}'
eval "${prefix}"'__force=${var___force:-false}'
eval "${prefix}"'__fast=${var___fast:-false}'
eval "${prefix}"'__skip_version_check=${var___skip_version_check:-false}'
eval "${prefix}"'__no_domain_poll=${var___no_domain_poll:-false}'
eval "${prefix}"'__no_state_poll=${var___no_state_poll:-false}'
eval "${prefix}"'__chaos=${var___chaos:-false}'
eval "${prefix}"'__volumes=${var___volumes:-false}'
eval "${prefix}"'__no_tty=${var___no_tty:-false}'
eval "${prefix}"'__user=${var___user:-}'
eval "${prefix}"'__bump=${var___bump:-false}'
eval "${prefix}"'__dev=${var___dev:-false}'
eval "${prefix}"'_type_=${var__type_:-}'; eval "${prefix}"'_app_=${var__app_:-}'
eval "${prefix}"'_service_=${var__service_:-}'
@ -359,16 +355,15 @@ eval "${prefix}"'upgrade=${var_upgrade:-false}'
eval "${prefix}"'doctor=${var_doctor:-false}'
eval "${prefix}"'help=${var_help:-false}'; local docopt_i=1
[[ $BASH_VERSION =~ ^4.3 ]] && docopt_i=2; for ((;docopt_i>0;docopt_i--)); do
declare -p "${prefix}__env" "${prefix}__stack" "${prefix}__skip_update" \
"${prefix}__help" "${prefix}__skip_check" "${prefix}__verbose" \
"${prefix}__debug" "${prefix}__no_prompt" "${prefix}__branch" \
"${prefix}__status" "${prefix}__server" "${prefix}__type" "${prefix}__domain" \
declare -p "${prefix}__skip_check" "${prefix}__no_prompt" "${prefix}__branch" \
"${prefix}__skip_update" "${prefix}__help" "${prefix}__env" "${prefix}__stack" \
"${prefix}__verbose" "${prefix}__debug" "${prefix}__status" \
"${prefix}__server" "${prefix}__type" "${prefix}__domain" \
"${prefix}__app_name" "${prefix}__pass" "${prefix}__secrets" "${prefix}__all" \
"${prefix}__update" "${prefix}__force" "${prefix}__fast" \
"${prefix}__skip_version_check" "${prefix}__no_domain_poll" \
"${prefix}__no_state_poll" "${prefix}__volumes" "${prefix}__no_tty" \
"${prefix}__user" "${prefix}__dev" "${prefix}_type_" "${prefix}_app_" \
"${prefix}_service_" "${prefix}_version_" "${prefix}_src_" "${prefix}_dst_" \
"${prefix}__update" "${prefix}__force" "${prefix}__fast" "${prefix}__chaos" \
"${prefix}__volumes" "${prefix}__no_tty" "${prefix}__user" "${prefix}__bump" \
"${prefix}__dev" "${prefix}_type_" "${prefix}_app_" "${prefix}_service_" \
"${prefix}_version_" "${prefix}_src_" "${prefix}_dst_" \
"${prefix}_backup_file_" "${prefix}_args_" "${prefix}_secret_" \
"${prefix}_cmd_" "${prefix}_data_" "${prefix}_volume_" "${prefix}_command_" \
"${prefix}_recipe_" "${prefix}_host_" "${prefix}_user_" "${prefix}_port_" \
@ -604,7 +599,11 @@ require_app_version() {
if [ -z "$VERSION" ]; then
warning "No version specified, dangerously using latest git 😨"
else
git checkout -q "$VERSION" || error "Can't find version $VERSION"
if [ "$abra___chaos" = "false" ]; then
git checkout -q "$VERSION" || error "Can't find version $VERSION"
else
warning "Chaos deploy specified, dangerously using latest git 😨"
fi
fi
}
@ -713,6 +712,7 @@ output_version_summary() {
CONSENT_TO_UPDATE=$abra___update
FORCE_DEPLOY=$abra___force
CHAOS_DEPLOY=$abra___chaos
local -a IS_AN_UPDATE="false"
local -a UNABLE_TO_DETECT="false"
@ -754,7 +754,11 @@ output_version_summary() {
if [ "$live_version" != "$service_tag" ] || [ "$live_digest" != "$service_digest" ]; then
IS_AN_UPDATE="true"
fi
echo " to be deployed: $(tput setaf 1)$service_tag ($service_digest)$(tput sgr0)"
if [ "$abra___chaos" = "true" ]; then
echo " to be deployed: $(tput setaf 1)$service_tag ($service_digest) (+ latest git)$(tput sgr0)"
else
echo " to be deployed: $(tput setaf 1)$service_tag ($service_digest)$(tput sgr0)"
fi
fi
else
if [[ $UNDEPLOYED_STATE == "true" ]]; then
@ -780,7 +784,8 @@ output_version_summary() {
else
if [[ $UNABLE_TO_DETECT == "false" ]] && \
[[ $UNDEPLOYED_STATE == "false" ]] && \
[[ $FORCE_DEPLOY == "false" ]]; then
[[ $FORCE_DEPLOY == "false" ]] && \
[[ $CHAOS_DEPLOY = "false" ]]; then
success "Nothing to deploy, you're on latest (use --force to re-deploy anyway)"
exit 0
fi
@ -1291,17 +1296,15 @@ _abra_backup_mysql() {
###### .. app deploy
help_app_deploy (){
echo "abra [options] app <app> deploy [--update] [--force] [--fast] [--skip-version-check] [--no-domain-poll] [--no-state-poll]
echo "abra [options] app <app> deploy [--update] [--force] [--fast]
Deploy app <app> to the configured server.
OPTIONS
--update Consent to deploying an updated app version
--force Force a deployment regardless of state
--skip-version-check Don't try and detect deployed version
--no-domain-poll Don't wait for the configured domain to come up
--no-state-poll Don't watch deployment state for success/failure
--fast Alias for --skip-version-check --no-domain-poll
--fast Run deployment without various safety checks
--chaos Deploy straight from latest Git version (potentially chaotic!)
POWERED BY
docker stack deploy -c compose.yml <app>"
@ -1315,9 +1318,9 @@ sub_app_deploy (){
NO_DOMAIN_POLL=true
NO_STATE_POLL=true
else
SKIP_VERSION_CHECK=$abra___skip_version_check
NO_DOMAIN_POLL=$abra___no_domain_poll
NO_STATE_POLL=$abra___no_state_poll
SKIP_VERSION_CHECK=false
NO_DOMAIN_POLL=false
NO_STATE_POLL=false
fi
if [ ! "$abra__version_" = "dev" ]; then
@ -2040,7 +2043,7 @@ sub_recipe_versions() {
###### .. recipe <recipe> release
help_recipe_release() {
echo "abra [options] recipe <recipe> release
echo "abra [options] recipe <recipe> release [--force] [--bump]
(For recipe maintainers)
@ -2053,6 +2056,7 @@ any of the images in <recipe>.
OPTIONS
--force Over-write existing tag; use this if you have a git tag for the
recipe version already, to make sure labels are in sync.
--bump Make an n+1 release (packager specific changes to recipe)
POWERED BY
skopeo inspect docker://image:tag
@ -2067,8 +2071,13 @@ sub_recipe_release() {
recipe="$abra__recipe_"
force="$abra___force"
bump="$abra___bump"
recipe_dir="$ABRA_DIR/apps/$recipe"
if [ "$bump" = "true" ] && [ "$force" = "true" ]; then
error "--bump and --force don't play nicely together"
fi
cd "$recipe_dir" || error "Can't find recipe dir '$recipe_dir'"
get_recipe_versions "$recipe"
@ -2081,15 +2090,18 @@ sub_recipe_release() {
latest_version_message=$(git show -s --format=%s)
fi
info "Latest available version: '$latest_version'"
info "Latest verion message: '$latest_version_message'"
info "Latest version message: '$latest_version_message'"
else
latest_version=""
latest_version_message="Initial tagged release"
info "No previous releases found"
if [ "$bump" = "true" ]; then
error "--bump can't do its work when there are no existing release versions"
fi
fi
current_tag=$(git tag --points-at HEAD)
if [ "$force" = "false" ] && [ -n "$current_tag" ]; then
if [ "$force" = "false" ] && [ -n "$current_tag" ] && [ "$bump" = "false" ]; then
success "$recipe is already on $current_tag, no release needed"
fi
@ -2112,7 +2124,12 @@ sub_recipe_release() {
new_version="false"
for compose_file in "${compose_files[@]}"; do
if [ "$bump" = "true" ]; then
continue # skip trying to upgrade labels for --bump logic
fi
mapfile -t services < <($YQ e -N '.services | keys | .[]' "$compose_file" | sort -u)
if [ "$compose_file" = "compose.yml" ] && ! printf '%s\0' "${services[@]}" | grep -Fqxz -- "app"; then
# shellcheck disable=SC2016
warning 'No `app` service found; which one should we use for the version number?'
@ -2188,7 +2205,7 @@ sub_recipe_release() {
success "All compose files updated; new version is $new_version"
if [ "$abra___no_prompt" = "false" ]; then
if [ "$abra___no_prompt" = "false" ] && [ "$bump" = "false" ]; then
read -rp "Commit your changes to git? [y/N]? " choice
if [ "${choice,,}" != "y" ]; then
@ -2196,7 +2213,7 @@ sub_recipe_release() {
fi
fi
if [ "$abra___no_prompt" = "false" ]; then
if [ "$abra___no_prompt" = "false" ] && [ "$bump" = "false" ]; then
git commit -avem "Version $new_version; sync labels" || exit
else
git commit -am "Version $new_version; sync labels" || true
@ -2225,7 +2242,7 @@ sub_recipe_release() {
if [ "$abra___no_prompt" = "false" ]; then
read -rp "Git push this new tag? [y/N]? " choice
if [ "${choice,,}" != "y" ]; then
if [ "${choice,,}" = "y" ]; then
git push && git push --tags
fi
else
@ -2522,8 +2539,7 @@ abra() {
abra___skip_check abra__backup_file_ abra___verbose abra___debug \
abra___help abra___branch abra___volumes abra__provider_ abra___type \
abra___dev abra___update abra___no_prompt abra___force \
abra___skip_version_check abra__recipe_ abra___no_domain_poll \
abra___fast abra__volume_ abra___no_state_poll
abra__recipe_ abra___fast abra__volume_ abra___bump abra___chaos
if ! type tput > /dev/null 2>&1; then
tput() {

View File

@ -1,6 +1,6 @@
#!/bin/bash
ABRA_VERSION="8.0.1"
ABRA_VERSION="9.0.0"
GIT_URL="https://git.autonomic.zone/coop-cloud/abra"
ABRA_SRC="$GIT_URL/raw/tag/$ABRA_VERSION/abra"
ABRA_DIR="${ABRA_DIR:-$HOME/.abra}"